package edu.uoc.rural;

import java.util.Enumeration;
import java.util.Hashtable;

import edu.uoc.rural.R;
import edu.uoc.rural.data.House;
import edu.uoc.rural.data.ListHouses;

import android.app.Activity;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.TableRow.LayoutParams;

public class Amenity extends Activity {
	
	private static int BLUE = -12490271;
	private static int WHITE = -1286;
	private static String TAG = "Amenity";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//Recovering parameters from main tabhouse
	    Bundle bundle = this.getIntent().getExtras();
	    int houseId = bundle.getInt("houseId", 0);
        
		//Finding house by id in houses list
	    ListHouses listHouses = new ListHouses(this.getApplicationContext());
	    House house = listHouses.findById(houseId);
		
		//Setting layout
		setContentView(R.layout.amenity);
		
		//Checking if info is populated
		if(house.areAmenitiesPopulated()){
			//Creating table layout
			TableLayout tbl = (TableLayout)findViewById(R.id.amenity);
			
			//Getting house amenities
			Hashtable<String,String> amenities = house.getAmenities();
			Enumeration<String> keys = amenities.keys();
			
			//Defining table layout parameters and margins
			TableLayout.LayoutParams params=new TableLayout.LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT );
			params.setMargins(1, 1, 1, 1);
			
			while(keys.hasMoreElements()){
				
				//Getting amenity info from hash table
				String amenity = (String)keys.nextElement();
				String available = amenities.get(amenity);
				
				//Creating table row and settings parameters
				TableRow tbrow=new TableRow(this);
			    tbrow.setBackgroundColor(BLUE);
			    tbrow.setLayoutParams(params);
			     
			    //First column text view
			    TextView tv1=new TextView(this);
			    tv1.setText(amenity);
			    tv1.setTextColor(WHITE);
			    tv1.setTypeface(null, Typeface.BOLD);
			     
			    //Second column text view
			    TextView tv2=new TextView(this);
			    tv2.setTextColor(WHITE);
			    tv2.setText(available);
			    tv2.setGravity(Gravity.CENTER);
			     
			    //Adding text views to row
			    tbrow.addView(tv1);
			    tbrow.addView(tv2);
			    
			    //Adding table row to table
			    tbl.addView(tbrow);
			}
		}else{

			//Showing no information available text
			TextView infoText=new TextView(this);
			infoText.setText("Informació no disponible");
			infoText.setTypeface(null, Typeface.BOLD);
			
			this.setContentView(infoText);
			
	    	Log.i(TAG,"onCreate(): the aren't amenities for this house");
		}
	}
}