package edu.uoc.rural;

import edu.uoc.rural.R;
import edu.uoc.rural.data.House;
import edu.uoc.rural.data.ListHouses;
import android.app.ListActivity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;


public class Info extends ListActivity {
	
	private static String TAG = "INFO";

    /** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//Recovering parameters from main tabhouse
	    Bundle bundle = this.getIntent().getExtras();
	    int houseId = bundle.getInt("houseId", 0);
		
		//Finding house by id in houses list
	    ListHouses listHouses = new ListHouses(this.getApplicationContext());
	    House house = listHouses.findById(houseId);
	
		String[] fields = new String[] {house.getDescription(),"Adreça: "+house.getAddress(),"Telèfon: "+house.getPhone(),
				"Correu: "+house.getEmail(),"Mostrar mapa"};

		//Creatting ArrayAdapter to show string fields in list
		this.setListAdapter(new ArrayAdapter<String>(this,R.layout.info, fields));
	}
	
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		super.onListItemClick(l, v, position, id);
		
		//Recovering parameters from main tabhouse
	    Bundle bundle = this.getIntent().getExtras();
	    int houseId = bundle.getInt("houseId", 0);
		
		//Finding house by id in houses list
	    ListHouses listHouses = new ListHouses(this.getApplicationContext());
	    House house = listHouses.findById(houseId);

		switch(position){
		
			//Starting call to house phone number
			case 2:
				try{
					//Getting phone number
					String phoneUri = "tel:"+house.getPhone();
					Intent phoneIntent = new Intent(Intent.ACTION_CALL);
					phoneIntent.setData(Uri.parse(phoneUri));
					//Starting call
					startActivity(phoneIntent);
				}catch(Exception e){
					Log.e(TAG,"Error starting phone call"+e.toString());
				}
				break;
			
			//Sending e-mail to house mail
			case 3:
				Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
				emailIntent.setType("plain/text");
				emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL,new String[]{house.getEmail()});
				startActivity(Intent.createChooser(emailIntent,"Enviar correu"));
				break;
				
			//Starting map activity to house location
			case 4:
				Intent map = new Intent(this,Map.class);
				// Get the item that was clicked
				Bundle bund = new Bundle();
				bund.putInt("houseId",house.getId());
				map.putExtras(bund);
				startActivity(map);
				break;
		}
	}
}