package edu.uoc.rural.Maps;

import java.util.ArrayList;

import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;

import com.google.android.maps.ItemizedOverlay;

import edu.uoc.rural.TabHouse;
import edu.uoc.rural.data.House;
import edu.uoc.rural.data.ListHouses;
import edu.uoc.rural.util.Services;


public class ListHouseItem extends ItemizedOverlay<MapHouseItem>{
	
	private static String TAG = "ListHouseItem";
	
	private Context mcontext;
	private ArrayList<MapHouseItem> mOverlays = new ArrayList<MapHouseItem>();
	public static final int HOUSE_TAPPED = 52;
	private Handler handler;
	
	public ListHouseItem(Drawable defaultMarker) {
		  super(boundCenterBottom(defaultMarker));
	}
	
	public ListHouseItem(Drawable defaultMarker, Context context) {
		  super(defaultMarker);
		  mcontext = context;
	}
	
	public void addOverlay(MapHouseItem overlay) {
	    mOverlays.add(overlay);
	    populate();
	}
	
	@Override
	protected MapHouseItem createItem(int i) {
	  return mOverlays.get(i);
	}
	
	@Override
	public int size() {
	  return mOverlays.size();
	}
	
	public Handler getHandler() {
		return handler;
	}

	public void setHandler(Handler handler) {
		this.handler = handler;
	}

	@Override
	protected boolean onTap(int index) {
	
		//Getting index of taped item
		MapHouseItem item = mOverlays.get(index);
		
		//Getting list houses
		ListHouses listHouses = new ListHouses(mcontext);
		
		//Getting house tapped
		House house = listHouses.findById(item.getId());
		
		//Checking if house is populated 
		if(!house.isInfoPopulated()){
			Services s = null;
			
			try{
	        	s = new Services();
	        }catch(Exception e){
	        	Log.e(TAG,"onCreate(): error creating anb initializing services");
	        }
	        //Retrieving house info from openerp and storing it in house object
	        if(s instanceof Services && !house.isInfoPopulated()){
	        	house.populateInfo(s);
	        }
		}
		
		//Creating TabHouse Intent
		Intent tabHouse = new Intent(mcontext,TabHouse.class);
		
		//Creating bundle to pass parameter
		Bundle bund = new Bundle();
		bund.putInt("houseId", house.getId());
		tabHouse.putExtras(bund);
		
		//Calling to next activity
		mcontext.startActivity(tabHouse);	
	  return true;
	}

}
