package edu.uoc.rural;

import java.util.Enumeration;
import java.util.Hashtable;

import edu.uoc.rural.R;
import edu.uoc.rural.data.House;
import edu.uoc.rural.data.ListHouses;

import android.app.Activity;
import android.graphics.Typeface;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.TableRow.LayoutParams;

public class Prices extends Activity {
	
	private static int BLUE = -12490271;
	private static int WHITE = -1286;
	private static String TAG = "Prices";
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//Recovering parameters from main tabhouse
	    Bundle bundle = this.getIntent().getExtras();
	    int houseId = bundle.getInt("houseId", 0);
        
		//Finding house by id in houses list
	    ListHouses listHouses = new ListHouses(this.getApplicationContext());
	    House house = listHouses.findById(houseId);
		
	    //Setting activity layout
		setContentView(R.layout.prices);
		
		
		//Checking if info is populated
		if(house.arePricesPopulated()){
			//Creating table layout
			TableLayout tbl = (TableLayout)findViewById(R.id.prices);
			
			//Getting house prices and seasons
			Hashtable<String,String> seasons = house.getSeasons();
			Hashtable<String,String> pricesWeek = house.getPricesWeek();
			Hashtable<String,String> pricesWeekend = house.getPricesWeekend();
			
			//Defining table layout parameters and margins
			TableLayout.LayoutParams RowParams=new TableLayout.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT );
			RowParams.setMargins(1, 1, 1, 1);
			
			//Getting season keys
			Enumeration<String> seasonKeys = seasons.keys();
	    	
		    //Filling table with prices    
			while(seasonKeys.hasMoreElements()){
		    	//Creating season table row
				TableRow tbs=new TableRow(this);
				tbs.setBackgroundColor(BLUE);
			    tbs.setLayoutParams(RowParams);
		    	
		    	//Text view with season name
			    String seasonName = (String)seasonKeys.nextElement();
		    	TextView tsname = new TextView(this);
		    	tsname.setLayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		    	tsname.setGravity(Gravity.CENTER);
		    	tsname.setText(seasonName);
				tsname.setTextColor(WHITE);
				tbs.addView(tsname);
				
				//Text view with week day price
				TextView tsweek = new TextView(this);
		    	tsweek.setText(pricesWeek.get(seasonName));
		    	tsweek.setLayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		    	tsweek.setGravity(Gravity.CENTER);
				tsweek.setTextColor(WHITE);
				tbs.addView(tsweek);
				
				//Text view with weekend day price
				TextView tsweekend = new TextView(this);
		    	tsweekend.setText(pricesWeekend.get(seasonName));
		    	tsweekend.setLayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		    	tsweekend.setGravity(Gravity.CENTER);
		    	tsweekend.setTextColor(WHITE);
				tbs.addView(tsweekend);
				
				//Adding row to table
				tbl.addView(tbs);
		    }
		}else{
			//Showing no information available text
			TextView infoText=new TextView(this);
			infoText.setText("Informació no disponible");
			infoText.setTypeface(null, Typeface.BOLD);
			
			this.setContentView(infoText);
			
	    	Log.i(TAG,"onCreate(): the aren't prices for this house");
		}
	}
}