package edu.uoc.rural;

import edu.uoc.rural.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

public class Rural extends Activity {
    /** Called when the activity is first created. */
	private static String TAG = "Rural";
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        //Setting layout
        setContentView(R.layout.rural); 
    }
    
    public void mainClickHandler (View view){
    	
    	//Checking if network is available
    	if(!networkAvailable()){
    		showAlert();
    		Log.i(TAG,"Network is not available");
	    }
    	else
    	{
	    	switch (view.getId()) {
	    		
	    		//Map button, starting map activity
	    		case R.id.mapButton: 
	    			Intent map_activity = new Intent(this,Map.class);
	    			startActivity(map_activity);
	    			break;
	    		
	    		//List button, starting list activity
	    		case R.id.listButton:
	    			Intent list_activity = new Intent(this,ListShow.class);
	    			startActivity(list_activity);
	    			break;
	    	}
	   	}
    }
    
    private boolean networkAvailable(){
    	ConnectivityManager conManager = (ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE);
    	if(conManager == null){
    		return false;
    	}else{
    		NetworkInfo[] networkInfo = conManager.getAllNetworkInfo();
    		if(networkInfo == null){
    			return false;
    		}else{
    			for (int i = 0; i < networkInfo.length; i++) {
    	            if (networkInfo[i].getState() == NetworkInfo.State.CONNECTED) {
    	               return true;
    	            }
    	         }
    		}
    	}
    	return false;
    }
    
    private void showAlert(){
    	AlertDialog alert = new AlertDialog.Builder(this).create();
		alert.setTitle("Avís: connexió no disponible");
		alert.setMessage("És necessari disposar de connexió a Internet per continuar");
		alert.setButton("Tanca", new DialogInterface.OnClickListener() {
		   public void onClick(DialogInterface dialog, int which) {
		   }
		});
		alert.setIcon(R.drawable.icon);
		alert.show();
    }
}