package edu.uoc.rural.util;

import com.google.android.maps.GeoPoint;

public class MathHelper {
	
	public static final double gp2m(GeoPoint firstPoint, GeoPoint secondPoint) {
				
		//Calculating First point coordinates
		double lat1 = firstPoint.getLatitudeE6() / 1E6;
		double lon1 = firstPoint.getLongitudeE6() / 1E6;
		
		//Calculating Second point coordinates
		double lat2 = secondPoint.getLatitudeE6() / 1E6;
		double lon2 = secondPoint.getLongitudeE6() / 1E6;
		
		//Calculating distance between points
		double dLat = Math.toRadians(lat2 - lat1);
		double dLon = Math.toRadians(lon2 - lon1);
		double a = Math.sin(dLat / 2) * Math.sin(dLat / 2)
				+ Math.cos(Math.toRadians(lat1))
				* Math.cos(Math.toRadians(lat2)) * Math.sin(dLon / 2)
				* Math.sin(dLon / 2);
		double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
		
		//6378140 its earth radius in meters
		return 6378140 * c;
	}	
}
